# Custom Tokens Module

This module makes it cleaner and more convenient to create custom tokens by defining them as a service.

## Requirements

This module requires the following modules to be installed:

- Drupal core ^10 || ^11
- Token

## Installation

- Install the module as you would normally install a contributed Drupal module.  
  Visit [this guide](https://www.drupal.org/docs/8/extending-drupal-8/installing-contributed-modules) for further
  information.

## Usage

Create a Class `MyToken`

```php
namespace Drupal\my_module\Token;

use Drupal\taas\Token\TokenInterface;

class MyToken implements TokenInterface {

  public function getValue(array $data, array $options): MarkupInterface|string|null {
    return 'My token value';
  }
}
```

Define the Token in `my_module.services.yml`

```yaml
services:
  my_module.token.my_token:
    class: Drupal\my_module\Token\MyToken
    tags:
      - name: taas.token
        type: 'node'
        token: '[node:my-token]'
        title: 'My Token'
```

Now you can use the custom token as: `[node:my-token]`

## Support

This is a contributed module and isn't officially supported by the Drupal community. However, you can open an issue on
the module's page on drupal.org if you find any bugs or have feature requests.
