<?php

namespace Drupal\taas\Token;

use Drupal\Component\Render\MarkupInterface;

/**
 * Interface for defining token functionality.
 */
interface TokenInterface {

  /**
   * Gets the value of the token.
   *
   * @param array $data
   *   An array of data to be used to replace the token.
   * @param array $options
   *   An array of options that can influence the token replacement.
   *
   * @return \Drupal\Component\Render\MarkupInterface|string|null
   *   The rendered value of the token, or NULL if the token cannot be replaced.
   */
  public function getValue(array $data, array $options): MarkupInterface|string|null;

}
